package com.eactive.eai.batch.job.jobItem.bokng;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.util.HashMap;
import java.util.Properties;

import com.eactive.eai.batch.job.jobConstant.TelegramKeys;
import com.eactive.eai.batch.job.jobHandle.JobProcessData;
import com.eactive.eai.batch.job.jobItem.DefaultTelegram;
import com.eactive.eai.batch.job.jobItem.TelegramService;
import com.eactive.eai.common.exception.ExceptionUtil;

public class SEND_BOKNG_0300 extends DefaultTelegram implements TelegramService {

    private int     SEND_LENGTH;        //TCP/IP전문 송신 BYTES수로 "업무구분코드"이후의 송신할 전문 길이
    private int     REAL_SEND_LENGTH;   //실제 송신할 전문의 총길이
    private int     MISSING_COUNT;      //결번갯수
    private String  MISSING_FIELD;
    
    private Properties telegramInfo;
    private File file;
    private FileOutputStream fout;

    /**
     * 생성자
     */
    public SEND_BOKNG_0300() {
        //결번확인통보
        MISSING_COUNT = 0;
    }

    /**
     * 전문조립
     */
    public boolean doExecute() {
        try {
        	        	
            boolean result = calculateMissingCount();
            if (!result) return false;

            result = calculateSendLength();
            if (!result) return false;

            //필수 (전문전체길이 - 길이부길이)
            compileField(0, ""+SEND_LENGTH, this.al_FieldProps[0]);
            
            //업무구분코드 - BOK
            compileField(1, telegramInfo.getProperty(TelegramKeys.BIZ_GBN), this.al_FieldProps[1]);
            
            //국고망: 'BOK', 한은망: 'FTP'참가기관 코드
            //- 국고망 : 현행 기관코드(외부기관 지로코드)를 맨 앞에서 
            //3자리 기재 (마지막자리는 공백)
            //- 한은망 : 현행 기관코드(한국은행 부여 기관코드)를 기재
            compileField(2, telegramInfo.getProperty(TelegramKeys.BANK_CODE), this.al_FieldProps[2]);
            
            //전문 목록 상의 전문종별
            compileField(3, this.getFldTelegramType(), this.al_FieldProps[3]);
            
            //거래구분코드 (File Name) 
            compileField(4, batchDoc.getBatchMsg().getHeader().getBizCode(), this.al_FieldProps[4]);
            
            //전문 발생 (송신) 주체, 참가기관 발생: 'B', 한국은행 발생: 'C'
            compileField(5, telegramInfo.getProperty(TelegramKeys.TRA_FLAG_BANK), this.al_FieldProps[5]);
            
            //전문처리결과, 정상: '000', 오류:  'A. 응답코드' 참조
            compileField(6, TelegramKeys.BOKGG_RES_CODE_SUCESS, this.al_FieldProps[6]);
            // 여기 까지 공통부
            
            //송수신 업무 구분코드.- BOK 중심 수신 구분, 항시 ‘S'
            compileField(7, getFldTrClass() , this.al_FieldProps[7]);

            //Block-NO
            compileField(8,  "" + batchDoc.getBatchMsg().getBody().getBlockNum() , this.al_FieldProps[8]);

            //Sequence-NO
            compileField(9,  "" + this.batchDoc.getBatchMsg().getBody().getSeqNum(), this.al_FieldProps[9]);

            //결번갯수
            compileField(10, "" + MISSING_COUNT, this.al_FieldProps[10]);
            //<< 전문 완성
            return true;
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI001";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error(e.getMessage(),e);
            return false;
        }
    }



    public boolean doPostExecute() {
        try {
            if (!super.doPostExecute()) return false;

            if (MISSING_COUNT==0) {
                fout.close();
            }
            //DB로그에 남길 전문 헤더 설정
            ByteArrayOutputStream baout = new ByteArrayOutputStream();
            for (int i=0; i<7; i++) { 
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramHeader(new String(baout.toByteArray()));

            //DB로그에 남길 전문 바디 설정
            baout = new ByteArrayOutputStream();
            for (int i=7; i< al_Field.size(); i++) {
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramBody(new String(baout.toByteArray()));

            return true;
        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI002";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error(ex.getMessage(),ex);
            return false;
        }
    }


    public boolean doPreExecute() {
        try {
            if (!super.doPreExecute()) return false;

            //BATCH작업구분코드 (processCode)에 따른 프로퍼티 정보 가져오기
            telegramInfo = getTelegramInfo();

            return true;
        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI003";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error(ex.getMessage(),ex);
            return false;
        }
    }

    /**
     * 실제 송신할 전문의 총길이를 리턴해준다.
     */
    public int getSendLength()
    {
        try {
            return REAL_SEND_LENGTH;  //실 DATA BYTE수
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI013";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);

            logger.error(e.getMessage(),e);
            return -1;
        }
    }

    /**
     * 비정형 필드에 대한 송신 길이를 계산해서 리턴해준다.
     *
     * 필드(idx)가 비정형 필드(XX)인지 점검하고 , 해당 필드에 대한 예상 길이를 계산하여 리턴하도록 한다
     *
     * 비정현 필드를 가지고 있는 개별 Telegram Class 에서 오버라이드 필요.
     */
    public int getCalculatedLength(int idx) {
        try {
            if (idx >= this.getFieldCount() ) {
                logger.debug("{} getCalculatedLength> parameter is bigger than field count", logHeader);
                String[] msgArgs = new String[2];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                msgArgs[1] = ""+idx;
                String errCode = "BECEAIFJI011";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                return -1;
            }
            if (this.getFieldLength(idx).equalsIgnoreCase(TelegramService.FIELD_NO_LENGTH)) {
               return MISSING_FIELD.length();
            } else {
                String[] msgArgs = new String[2];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                msgArgs[1] = ""+idx;
                String errCode = "BECEAIFJI012";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                return -1;
            }
        }catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI005";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error(e.getMessage(),e);
            return -1;
        }
    }

    /**
     * return value : 0 no left data to be sent
     *                -1 error
     *                >0 data copied to the data field
     *
     * 비정형 필드인 결번확인의 데이터를 얻어낸다.
     * 결번확인 데이터를 실어주고 결번확인 필드의 길이를 반환한다.
     */
    public int getInformalFieldSendData(int idx, byte[] data) {
        try {
            if (idx >= this.getFieldCount() ) {
                logger.debug("{}  getInformalFieldSendData> " +idx+ " is bigger than field count", logHeader);
                String[] msgArgs = new String[2];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                msgArgs[1] = ""+idx;
                String errCode = "BECEAIFJI011";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                return -1;
            }
            if (data.length < MISSING_FIELD.length()) {
                logger.debug("{}  getInformalFieldSendData> InformalFieldSendData size is bigger than buffer size", logHeader);
                String[] msgArgs = new String[1];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                String errCode = "BECEAIFJI014";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                return -1;
            }

            ByteArrayInputStream bin = new ByteArrayInputStream(MISSING_FIELD.getBytes());
            bin.read(data, 0, MISSING_FIELD.length());
            return MISSING_FIELD.length();
        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI006";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error(ex.getMessage(),ex);
            return -1;
        }
    }

    private boolean calculateSendLength () {
        try {
            for (int i=1; i< this.al_Field.size()-1; i++) { //마지막 결번확인은 가변길이
                byte[] aField = (byte[]) this.al_Field.get(i);
                SEND_LENGTH += aField.length;
            }
            SEND_LENGTH += MISSING_FIELD.length();  //비정형 필드인 결번확인의 길이 더함.
            REAL_SEND_LENGTH = SEND_LENGTH;
            for (int i=0; i < 1 ; i++) {
                byte[] aField = (byte[]) this.al_Field.get(i);
                REAL_SEND_LENGTH += aField.length;
            }
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI025";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error(e.getMessage(),e);
            return false;
        }

        return true;
    }

    private boolean calculateMissingCount () {
        try {

            String uuid = this.batchDoc.getBatchMsg().getHeader().getUUID();
            int seq_no  = this.batchDoc.getBatchMsg().getBody().getSeqNum();

            JobProcessData job = JobProcessData.getInstance();
            HashMap<String, Object> hm = job.getBatchStageData(uuid);

            byte[] _missingNm = new byte[seq_no];
            for (int i=0; i<seq_no; i++) {
                _missingNm[i] = '1';    //모든 결번은 1로 초기화
            }

            @SuppressWarnings("unchecked")
            HashMap<Integer, byte[]> block_data = (HashMap<Integer, byte[]>)hm.get(JobProcessData.PROCDATA_BLOCKDATA);

            if (block_data == null ){
                MISSING_COUNT = seq_no;
                for (int i = 0; i<seq_no; i++)
                    _missingNm[i] = '0';
            }else{
                for (int i = 0; i<seq_no; i++) {        //받은 seq_no만큼만 데이터 확인
                    byte[] data = (byte[]) block_data.get( new Integer(i) );
                    if (data == null ) {
                        _missingNm[i] = '0';    //결번이 발생한 seq만 '0' 설정
                        MISSING_COUNT++;
                        logger.info("{} calculateMissingCount >> missing telegram : [" + i + "]", logHeader);
                    }
                }
            }
            if (MISSING_COUNT == 0) {
                if (!createFile()) {
                    return false;
                }
                
                for (int i = 0; i<seq_no; i++) {        //받은 seq_no만큼만 데이터 확인하여 기록
                    byte[] data = (byte[]) block_data.get(new Integer(i));
                    int recLen = batchDoc.getBatchMsg().getHeader().getRecLen();
                    if ( recLen < 1 ){
                    	recLen = data.length;
                    }
                    byte[]layout = new byte[recLen];
                    for (int inx = 0; inx < layout.length; inx++) {
                        layout[inx] = ' ';
                    }

                    int dataCnt = data.length / recLen ;
                    for (int jnx = 0; jnx < dataCnt; jnx++) {
                        System.arraycopy( data,jnx*layout.length,layout,0,layout.length);
                        fout.write(layout);
                        fout.write( '\n' );
                        long lnCurSize = batchDoc.getBatchMsg().getBody().getCurFileSize()+recLen;
                        batchDoc.getBatchMsg().getBody().setCurFileSize(lnCurSize);
                    }
                }
                hm.put(JobProcessData.PROCDATA_BLOCKDATA, null);    //데이터 기록후 HashMap 초기화
            }

            this.MISSING_FIELD = new String (_missingNm);
            this.batchDoc.getBatchMsg().getBody().setMissingNmCount(MISSING_COUNT);
            this.batchDoc.getBatchMsg().getBody().setMissingNmField(MISSING_FIELD);

        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI027";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error(e.getMessage(),e);
            return false;
        }
        return true;
    }

    private boolean createFile () {
        try {
            String strFullPath = batchDoc.getBatchMsg().getHeader().getFilePath();
            if (strFullPath.charAt(strFullPath.length()-1) != File.separatorChar) {
                strFullPath = strFullPath + File.separator;
            }
            strFullPath = strFullPath + batchDoc.getBatchMsg().getHeader().getFileName();
            logger.info("{}  getCalculatedLength >> File full-path [" + strFullPath + "]", logHeader);
            file = new File(strFullPath);
            fout = new FileOutputStream(file, true);   //bytes will be written to the end of the file rather than the beginning
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI028";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error(e.getMessage(),e);
            return false;
        }
        return true;
    }

    //---------------- 특정 필드값을 구하는 부분
    // 전문종별코드 필드값 리턴
    public String getTelegramType()
    {
		return super.getFieldValueString(3);
    }
    // 거래구분코드 필드값 리턴
    public String getTrClass()
    {
		return super.getFieldValueString(7);
    }
    //응답코드 필드값 리턴
    public String getResCode()
    {
		return super.getFieldValueString(6);
    }
}
